import type { NextPage } from "next";
import Head from "next/head";
import { useCallback, useEffect, useState } from "react";
import authTokenService from "core/services/authTokenService";
import redirectTo from "core/utils/redirectTo";
import TgAuth from "core/uikit/TgAuth/TgAuth";

import styles from "styles/pages/AuthPage.module.scss";
import { useDispatch } from "react-redux";
import { userAuth } from "core/redux/actions/auth";
import Button from "core/uikit/Button";
import ModalContainer, { ModalForm } from "core/uikit/ModalContainer";
import Input from "core/uikit/Input";
import Typo from "core/uikit/Typo";
import ModalHeader from "core/uikit/ModalContainer/components/ModalHeader/ModalHeader";
import ModalFooter from "core/uikit/ModalContainer/components/ModalFooter/ModalFooter";
import { useForm } from "core/hooks/useForm";
import QrReader from 'react-qr-scanner'

const Home: NextPage = () => {
  const [showModal, setShowModal] = useState(false);
  const [showQR, setShowQR] = useState(false);

  const dispatch = useDispatch();
  // const {
  //   isAuthInProgress,
  //   authError
  // } = useSelector<IRootReducer, IAuthState>((store)=>store.auth);
  
  useEffect(()=>{
    if(authTokenService.hasTokenInLocalstorage()) {
      redirectTo('/panel/editor');
    }
  }, [])

  const handleAuth = useCallback((formData)=>{
    dispatch(userAuth({
      cafeCode: formData.cafeCode,
      code: formData.code.toString(),
      userType: 'employee'
    }))
  }, [dispatch])

  var {
    onChangeField,
    handleSubmit,
    formData,
    reinit
  } = useForm(handleAuth, {});
  
  const onScan = useCallback((data) => {
    if(data) {
      try{
        const authData = JSON.parse(data.text);
        if(authData.cafeCode && authData.code) {
          handleAuth({
            cafeCode: authData.cafeCode,
            code: authData.code
          })
          setShowQR(false);
        }
      } catch {

      }
    }
  }, [])

  return (
    <>
      {showQR && (
        <div className={styles.main__qrWrapper} onClick={() => {setShowQR(false)}}>
          <QrReader
            delay={1000}
            onScan={onScan}
            facingMode="rear"
          />
        </div>
      )}
      {showModal && (
        <ModalContainer onClose={() => setShowModal(false)}>
          <ModalHeader>
            <Typo variant='title-16-b'>Авторизация</Typo>
          </ModalHeader>
          <ModalForm>
            <Input
              label="Код заведения"
              value={formData['cafeCode']}
              onChange={onChangeField('cafeCode')}
              placeholder="6 Символов (A-Z, 0-9)"
            />
            <Input
              label="Код сотрудника"
              value={formData['code']}
              onChange={onChangeField('code')}
            />
          </ModalForm>
          <ModalFooter>
            <Button round onClick={handleSubmit}>Войти</Button>
          </ModalFooter>
        </ModalContainer>
      )}
      <div className={styles.page}>
        <Head>
          <title>Create Next App</title>
          <meta name="description" content="Generated by create next app" />
          <link rel="icon" href="/favicon.ico" />
        </Head>
        <main className={styles.main}>
          <div className={styles.authCard}>
            {/* {isAuthInProgress && <div className={styles.authCard__loader}/>} */}
            <span className={styles.authCard__brand}>MD.Cafe</span>

            <div className={styles.authCard__content}>
              <div className={styles.authCard__contentInner}>
                <h1 className={styles.authCard__title}>Авторизация</h1>
                <h2 className={styles.authCard__subtitle}>Вход в панель управления</h2>
              </div>
              <hr />
              <div className={styles.authCard__actions}>
                <Button className={styles.authCard__button} theme='primary' variant='filled' size="md" round onClick={() => setShowQR(true)}>Сканировать QR</Button>
                <Button className={styles.authCard__button} theme='primary' variant='filled' size="md" round onClick={() => setShowModal(true)}>Ручной вход</Button>
              </div>
            </div>

            <span className={styles.authCard__copy}>Powered by M.Dev</span>
          </div>
        </main>
      </div>
    </>
  );
};

export default Home;
